program Casm2Basm;

uses
  Windows,
  KOL,
  UnitConvert in 'UnitConvert.pas';

{$APPTYPE CONSOLE}

procedure DoWork;
var s, u: String;
    d: PDirList;

    procedure DoStep( nstep: Integer );
    var i: Integer;
    begin
      UnitConvert.Step := nstep;
      for i := 0 to d.Count-1 do
      begin
        s := d.Path + d.Names[ i ];
        if FileExists( s ) then
        begin
          u := '';
          if nstep = 2 then
            u := BuildUses2( ExtractFileNameWOext( d.Names[ i ] ) );
          ConvertFile( s, u );
        end;
      end;
    end;

begin
  Writeln( 'Casm2Basm v1.0 (C) by Vladimir Kladov 2007' );
  if ParamCount < 1 then
  begin
    Writeln( 'Usage: Casm2Basm [path]' );
    Writeln( ' where path is path to asm-file or to directory.' );
    Readln;
    Exit;
  end;
  s := ParamStr( 1 );
  Step := 2;
  if FileExists( s ) then
    ConvertFile( s, '' )
  else
  if DirectoryExists( s ) then
  begin
    d := NewDirList( IncludeTrailingPathDelimiter( s ), '*.asm', FILE_ATTRIBUTE_NORMAL );
    TRY
      DoStep( 1 );
      DoStep( 2 );
    FINALLY
      d.Free;
    END;
  end;
end;

begin
  UseInputOutput;
  DoWork;
end.
