unit ex_math;

interface

uses Windows, KOL, KOLmath;

function _exp( d: Double ): Double; cdecl;
function _log( d: Double ): Double; cdecl;
function itrunc( d: Double ): Integer; cdecl;
function _sqrt( d: Double ): Double; cdecl;
function _atan2( y, x: Double ): Double; cdecl;
function _fabs( d: Double ): Double; cdecl;
procedure __ftol2( i: Integer );
function _pow( x, y: Double ): Double; cdecl;
function floor( d: Double ): Integer; cdecl;

var __imp__rand: Pointer = @ itrunc;
    __imp__floor: Pointer = @ floor;

implementation

function _exp( d: Double ): Double; cdecl;
begin
  Result := System.Exp( d );
end;

function _log( d: Double ): Double; cdecl;
begin
  Result := KOLmath.Log2( d );
end;

function itrunc( d: Double ): Integer; cdecl;
begin
  Result := Trunc( d );
end;

function _sqrt( d: Double ): Double; cdecl;
begin
  Result := sqrt( d );
end;

function _atan2( y, x: Double ): Double; cdecl;
begin
  Result := KOLmath.ArcTan2( y, x );
end;

function _fabs( d: Double ): Double; cdecl;
begin
  Result := abs( d );
end;

function _pow( x, y: Double ): Double; cdecl;
begin
  Result := Power( x, y );
end;

function floor( d: Double ): Integer; cdecl;
begin
  Result := KOLmath.floor( d );
end;

procedure __ftol2( i: Integer );
asm
//_ftol2:
@00474328:  push        ebp
@00474329:  mov         ebp,esp
@0047432B:  sub         esp,20h
@0047432E:  and         esp,0FFFFFFF0h
@00474331:  fld         st(0)
@00474333:  fst         dword ptr [esp+18h]
@00474337:  fistp       qword ptr [esp+10h]
@0047433B:  fild        qword ptr [esp+10h]
@0047433F:  mov         edx,dword ptr [esp+18h]
@00474343:  mov         eax,dword ptr [esp+10h]
@00474347:  test        eax,eax
@00474349:  je          @integer_QnaN_or_zero

@arg_is_not_integer_QnaN:
@0047434B:  fsubp       st(1),st
@0047434D:  test        edx,edx
@0047434F:  jns         @positive //(47436Fh)
@00474351:  fstp        dword ptr [esp]
@00474354:  mov         ecx,dword ptr [esp]
@00474357:  xor         ecx,80000000h
@0047435D:  add         ecx,7FFFFFFFh
@00474363:  adc         eax,0
@00474366:  mov         edx,dword ptr [esp+14h]
@0047436A:  adc         edx,0
@0047436D:  jmp         @localexit //(47439Bh)

@positive:
@0047436F:  fstp        dword ptr [esp]
@00474372:  mov         ecx,dword ptr [esp]
@00474375:  add         ecx,7FFFFFFFh
@0047437B:  sbb         eax,0
@0047437E:  mov         edx,dword ptr [esp+14h]
@00474382:  sbb         edx,0
@00474385:  jmp         @localexit //(47439Bh)

@integer_QnaN_or_zero:
@00474387:  mov         edx,dword ptr [esp+14h]
@0047438B:  test        edx,7FFFFFFFh
@00474391:  jne         @arg_is_not_integer_QnaN //(47434Bh)
@00474393:  fstp        dword ptr [esp+18h]
@00474397:  fstp        dword ptr [esp+18h]

@localexit:
@0047439B:  leave
@0047439C:  ret
end;

end.
