unit ex_tif_utils;

interface

uses Windows, KOL;

type
  TCompareProc = function( v1, v2: Pointer ): Integer; cdecl;

procedure qsort( base: Pointer; num: Integer; width: Integer; Compare: TCompareProc ); cdecl;
procedure ErrExit;
procedure Dummy;
procedure longjmp;
procedure __setjmp3;
procedure __purecall;

var __imp__qsort: Pointer = @ qsort;
    //__imp__fprintf: Pointer = @ Dummy;
    //__imp__sprintf: Pointer = @ Dummy;
    __imp__exit: Pointer = @ ErrExit;
    __imp___iob: Pointer = @ Dummy;
    __imp__longjmp: Pointer = @ longjmp;
    __imp__setjmp3: Pointer = @ __setjmp3;

implementation

(***
*swap(a, b, width) - swap two elements
*
*Purpose:
*       swaps the two array elements of size width
*
*Entry:
*       char *a, *b = pointer to two elements to swap
*       size_t width = width in bytes of each array element
*
*Exit:
*       returns void
*
*Exceptions:
*
*******************************************************************************/

static void __cdecl swap (
    char *a,
    char *b,
    size_t width
    )*)
procedure swap( a, b: PChar; width: Integer ); stdcall;
var tmp: Char;
begin
asm
{
1023E870  push        ebp
1023E871  mov         ebp,esp
1023E873  push        ecx
    char tmp;

    if ( a != b )}
@1023E874:  mov         eax,dword ptr [a]
@1023E877:  cmp         eax,dword ptr [b]
@1023E87A:  je          @1023E8BA
{        /* Do the swap one character at a time to avoid potential alignment
           problems. */
        while ( width-- ) {}
@1023E87C:  mov         ecx,dword ptr [width]
@1023E87F:  mov         edx,dword ptr [width]
@1023E882:  sub         edx,1
@1023E885:  mov         dword ptr [width],edx
@1023E888:  test        ecx,ecx
@1023E88A:  je          @1023E8BA
//            tmp = *a;
@1023E88C:  mov         eax,dword ptr [a]
@1023E88F:  mov         cl,byte ptr [eax]
@1023E891:  mov         byte ptr [tmp],cl
//            *a++ = *b;
@1023E894:  mov         edx,dword ptr [a]
@1023E897:  mov         eax,dword ptr [b]
@1023E89A:  mov         cl,byte ptr [eax]
@1023E89C:  mov         byte ptr [edx],cl
@1023E89E:  mov         edx,dword ptr [a]
@1023E8A1:  add         edx,1
@1023E8A4:  mov         dword ptr [a],edx
//            *b++ = tmp;
@1023E8A7:  mov         eax,dword ptr [b]
@1023E8AA:  mov         cl,byte ptr [tmp]
@1023E8AD:  mov         byte ptr [eax],cl
@1023E8AF:  mov         edx,dword ptr [b]
@1023E8B2:  add         edx,1
@1023E8B5:  mov         dword ptr [b],edx
//        }
@1023E8B8:  jmp         @1023E87C
//}
@1023E8BA:  {mov         esp,ebp
@1023E8BC:  pop         ebp
@1023E8BD:  ret}
end;
end;


(***
*shortsort(hi, lo, width, comp) - insertion sort for sorting short arrays
*
*Purpose:
*       sorts the sub-array of elements between lo and hi (inclusive)
*       side effects:  sorts in place
*       assumes that lo < hi
*
*Entry:
*       char *lo = pointer to low element to sort
*       char *hi = pointer to high element to sort
*       size_t width = width in bytes of each array element
*       int (*comp)() = pointer to function returning analog of strcmp for
*               strings, but supplied by user for comparing the array elements.
*               it accepts 2 pointers to elements and returns neg if 1<2, 0 if
*               1=2, pos if 1>2.
*
*Exit:
*       returns void
*
*Exceptions:
*
*******************************************************************************/

static void __cdecl shortsort (
    char *lo,
    char *hi,
    size_t width,
    int (__cdecl *comp)(const void *, const void * )
    )*)

procedure shortsort( lo, hi: PChar; width: Integer; Comapre: TCompareProc ); stdcall;
var p, max: PChar;
begin
asm
{
1023E800  push        ebp
1023E801  mov         ebp,esp
1023E803  sub         esp,8
    char *p, *max;

    /* Note: in assertions below, i and j are alway inside original bound of
       array to sort. */

    while (hi > lo) {}
@1023E806:  mov         eax,dword ptr [hi]
@1023E809:  cmp         eax,dword ptr [lo]
@1023E80C:  jbe         @1023E869
{        /* A[i] <= A[j] for i <= j, j > hi */
        max = lo;}
@1023E80E:  mov         ecx,dword ptr [lo]
@1023E811:  mov         dword ptr [max],ecx
//        for (p = lo+width; p <= hi; p += width) {
@1023E814:  mov         edx,dword ptr [lo]
@1023E817:  add         edx,dword ptr [width]
@1023E81A:  mov         dword ptr [p],edx
@1023E81D:  jmp         @1023E828
@1023E81F:  mov         eax,dword ptr [p]
@1023E822:  add         eax,dword ptr [width]
@1023E825:  mov         dword ptr [p],eax
@1023E828:  mov         ecx,dword ptr [p]
@1023E82B:  cmp         ecx,dword ptr [hi]
@1023E82E:  ja          @1023E84A
{            /* A[i] <= A[max] for lo <= i < p */
            if (comp(p, max) > 0) {}
@1023E830:  mov         edx,dword ptr [max]
@1023E833:  push        edx
@1023E834:  mov         eax,dword ptr [p]
@1023E837:  push        eax
@1023E838:  call        dword ptr [comp]
@1023E83B:  add         esp,8
@1023E83E:  test        eax,eax
@1023E840:  jle         @1023E848
//                max = p;
@1023E842:  mov         ecx,dword ptr [p]
@1023E845:  mov         dword ptr [max],ecx
(*            }
            /* A[i] <= A[max] for lo <= i <= p */
        }*)
@1023E848:  jmp         @1023E81F

{        /* A[i] <= A[max] for lo <= i <= hi */

        swap(max, hi, width);}
@1023E84A:  mov         edx,dword ptr [width]
@1023E84D:  push        edx
@1023E84E:  mov         eax,dword ptr [hi]
@1023E851:  push        eax
@1023E852:  mov         ecx,dword ptr [max]
@1023E855:  push        ecx
@1023E856:  call        swap //(1023E870h)
@1023E85B:  add         esp,0Ch

{        /* A[i] <= A[hi] for i <= hi, so A[i] <= A[j] for i <= j, j >= hi */

        hi -= width;}
@1023E85E:  mov         edx,dword ptr [hi]
@1023E861:  sub         edx,dword ptr [width]
@1023E864:  mov         dword ptr [hi],edx

(*        /* A[i] <= A[j] for i <= j, j > hi, loop top condition established */
    }*)
@1023E867:  jmp         @1023E806
(*    /* A[i] <= A[j] for i <= j, j > lo, which implies A[i] <= A[j] for i < j,
       so array is sorted */
} *)
@1023E869:  {mov         esp,ebp
@1023E86B:  pop         ebp
@1023E86C:  ret}
end;
end;


//--- f:\vs70builds\3077\vc\crtbld\crt\src\qsort.c -------------------------------
(***
*qsort.c - quicksort algorithm; qsort() library function for sorting arrays
*
*       Copyright (c) Microsoft Corporation. All rights reserved.
*
*Purpose:
*       To implement the qsort() routine for sorting arrays.
*
*******************************************************************************)
(*
#include <cruntime.h>
#include <stdlib.h>
#include <search.h>
#include <internal.h>

/* Always compile this module for speed, not size */
#pragma optimize("t", on)

/* prototypes for local routines */
static void __cdecl shortsort(char *lo, char *hi, size_t width,
                int (__cdecl *comp)(const void *, const void * ));
static void __cdecl swap(char *p, char *q, size_t width);

/* this parameter defines the cutoff between using quick sort and
   insertion sort for arrays; arrays with lengths shorter or equal to the
   below value use insertion sort */
*)

//#define CUTOFF 8            /* testing shows that this is good value */
const CUTOFF = 8;

(***
*qsort(base, num, wid, comp) - quicksort function for sorting arrays
*
*Purpose:
*       quicksort the array of elements
*       side effects:  sorts in place
*       maximum array size is number of elements times size of elements,
*       but is limited by the virtual address space of the processor
*
*Entry:
*       char *base = pointer to base of array
*       size_t num  = number of elements in the array
*       size_t width = width in bytes of each array element
*       int (*comp)() = pointer to function returning analog of strcmp for
*               strings, but supplied by user for comparing the array elements.
*               it accepts 2 pointers to elements and returns neg if 1<2, 0 if
*               1=2, pos if 1>2.
*
*Exit:
*       returns void
*
*Exceptions:
*
*******************************************************************************/

/* sort the array between lo and hi (inclusive) *)

//#define STKSIZ (8*sizeof(void*) - 2)
const STKSIZ = (8*sizeof(Pointer) - 2);

{void __cdecl qsort (
    void *base,
    size_t num,
    size_t width,
    int (__cdecl *comp)(const void *, const void *)
    )}
procedure qsort( base: Pointer; num: Integer; width: Integer; Compare: TCompareProc ); cdecl;
var lo, hi, mid, loguy, higuy: PChar;
    size: Integer;
    lostk, histk: array[ 0..STKSIZ-1 ] of PChar;
    stkptr: Integer;
begin
asm
{@1023E460:  push        ebp
@1023E461:  mov         ebp,esp
@1023E463:  sub         esp,110h}
{    /* Note: the number of stack entries required is no more than
       1 + log2(num), so 30 is sufficient for any array */
    char *lo, *hi;              /* ends of sub-array currently sorting */
    char *mid;                  /* points to middle of subarray */
    char *loguy, *higuy;        /* traveling pointers for partition step */
    size_t size;                /* size of the sub-array */
    char *lostk[STKSIZ], *histk[STKSIZ];
    int stkptr;                 /* stack for saving sub-array to be processed */

    if (num < 2 || width == 0)}
@1023E469:  cmp         dword ptr [num],2
@1023E46D:  jb          @1023E475
@1023E46F:  cmp         dword ptr [width],0
@1023E473:  jne         @1023E47A
//        return;                 /* nothing to do */
@1023E475:  jmp         @1023E7F1

//    stkptr = 0;                 /* initialize stack */
@1023E47A:  mov         dword ptr [stkptr],0

//    lo = base;
@1023E484:  mov         eax,dword ptr [base]
@1023E487:  mov         dword ptr [lo],eax
//    hi = (char *)base + width * (num-1);        /* initialize limits */
@1023E48A:  mov         ecx,dword ptr [num]
@1023E48D:  sub         ecx,1
@1023E490:  imul        ecx,dword ptr [width]
@1023E494:  add         ecx,dword ptr [base]
@1023E497:  mov         dword ptr [hi],ecx

{    /* this entry point is for pseudo-recursion calling: setting
       lo and hi and jumping to here is like recursion, but stkptr is
       preserved, locals aren't, so we preserve stuff on the stack */
recurse:

    size = (hi - lo) / width + 1;        /* number of el's to sort */}
@1023E49D:  mov         eax,dword ptr [hi]
@1023E4A3:  sub         eax,dword ptr [lo]
@1023E4A6:  xor         edx,edx
@1023E4A8:  div         eax,dword ptr [width]
@1023E4AB:  add         eax,1
@1023E4AE:  mov         dword ptr [size],eax

{    /* below a certain size, it is faster to use a O(n^2) sorting method */
    if (size <= CUTOFF) {}
@1023E4B4:  cmp         dword ptr [size],8
@1023E4BB:  ja          @1023E4DD
//        shortsort(lo, hi, width, comp);
@1023E4BD:  mov         edx,dword ptr [comp]
@1023E4C0:  push        edx
@1023E4C1:  mov         eax,dword ptr [width]
@1023E4C4:  push        eax
@1023E4C5:  mov         ecx,dword ptr [hi]
@1023E4CB:  push        ecx
@1023E4CC:  mov         edx,dword ptr [lo]
@1023E4CF:  push        edx
@1023E4D0:  call        shortsort //(1023E800h)
@1023E4D5:  add         esp,10h
(*    }
    else {*)
@1023E4D8:  jmp         @1023E7BB
{        /* First we pick a partitioning element.  The efficiency of the
           algorithm demands that we find one that is approximately the median
           of the values, but also that we select one fast.  We choose the
           median of the first, middle, and last elements, to avoid bad
           performance in the face of already sorted data, or data that is made
           up of multiple sorted runs appended together.  Testing shows that a
           median-of-three algorithm provides better performance than simply
           picking the middle element for the latter case. */

        mid = lo + (size / 2) * width;      /* find middle element */}
@1023E4DD:  mov         eax,dword ptr [size]
@1023E4E3:  shr         eax,1
@1023E4E5:  imul        eax,dword ptr [width]
@1023E4E9:  add         eax,dword ptr [lo]
@1023E4EC:  mov         dword ptr [mid],eax

{        /* Sort the first, middle, last elements into order */
        if (comp(lo, mid) > 0) {}
@1023E4EF:  mov         ecx,dword ptr [mid]
@1023E4F2:  push        ecx
@1023E4F3:  mov         edx,dword ptr [lo]
@1023E4F6:  push        edx
@1023E4F7:  call        dword ptr [comp]
@1023E4FA:  add         esp,8
@1023E4FD:  test        eax,eax
@1023E4FF:  jle         @1023E515
//            swap(lo, mid, width);
@1023E501:  mov         eax,dword ptr [width]
@1023E504:  push        eax
@1023E505:  mov         ecx,dword ptr [mid]
@1023E508:  push        ecx
@1023E509:  mov         edx,dword ptr [lo]
@1023E50C:  push        edx
@1023E50D:  call        swap //(1023E870h)
@1023E512:  add         esp,0Ch
(*        }
        if (comp(lo, hi) > 0) {*)
@1023E515:  mov         eax,dword ptr [hi]
@1023E51B:  push        eax
@1023E51C:  mov         ecx,dword ptr [lo]
@1023E51F:  push        ecx
@1023E520:  call        dword ptr [comp]
@1023E523:  add         esp,8
@1023E526:  test        eax,eax
@1023E528:  jle         @1023E541
//            swap(lo, hi, width);
@1023E52A:  mov         edx,dword ptr [width]
@1023E52D:  push        edx
@1023E52E:  mov         eax,dword ptr [hi]
@1023E534:  push        eax
@1023E535:  mov         ecx,dword ptr [lo]
@1023E538:  push        ecx
@1023E539:  call        swap //(1023E870h)
@1023E53E:  add         esp,0Ch
(*        }
        if (comp(mid, hi) > 0) {*)
@1023E541:  mov         edx,dword ptr [hi]
@1023E547:  push        edx
@1023E548:  mov         eax,dword ptr [mid]
@1023E54B:  push        eax
@1023E54C:  call        dword ptr [comp]
@1023E54F:  add         esp,8
@1023E552:  test        eax,eax
@1023E554:  jle         @1023E56D
//            swap(mid, hi, width);
@1023E556:  mov         ecx,dword ptr [width]
@1023E559:  push        ecx
@1023E55A:  mov         edx,dword ptr [hi]
@1023E560:  push        edx
@1023E561:  mov         eax,dword ptr [mid]
@1023E564:  push        eax
@1023E565:  call        swap //(1023E870h)
@1023E56A:  add         esp,0Ch
(*        }

        /* We now wish to partition the array into three pieces, one consisting
           of elements <= partition element, one of elements equal to the
           partition element, and one of elements > than it.  This is done
           below; comments indicate conditions established at every step. */

        loguy = lo;*)
@1023E56D:  mov         ecx,dword ptr [lo]
@1023E570:  mov         dword ptr [loguy],ecx
//        higuy = hi;
@1023E576:  mov         edx,dword ptr [hi]
@1023E57C:  mov         dword ptr [higuy],edx

{        /* Note that higuy decreases and loguy increases on every iteration,
           so loop must terminate. */
        for (;;) {
            /* lo <= loguy < hi, lo < higuy <= hi,
               A[i] <= A[mid] for lo <= i <= loguy,
               A[i] > A[mid] for higuy <= i < hi,
               A[hi] >= A[mid] */

            /* The doubled loop is to avoid calling comp(mid,mid), since some
               existing comparison funcs don't work when passed the same
               value for both pointers. */

            if (mid > loguy) {}
@1023E582:  mov         eax,dword ptr [mid]
@1023E585:  cmp         eax,dword ptr [loguy]
@1023E58B:  jbe         @1023E5BC
(*                do  {
                    loguy += width;*)
@1023E58D:  mov         ecx,dword ptr [loguy]
@1023E593:  add         ecx,dword ptr [width]
@1023E596:  mov         dword ptr [loguy],ecx
//                } while (loguy < mid && comp(loguy, mid) <= 0);
@1023E59C:  mov         edx,dword ptr [loguy]
@1023E5A2:  cmp         edx,dword ptr [mid]
@1023E5A5:  jae         @1023E5BC
@1023E5A7:  mov         eax,dword ptr [mid]
@1023E5AA:  push        eax
@1023E5AB:  mov         ecx,dword ptr [loguy]
@1023E5B1:  push        ecx
@1023E5B2:  call        dword ptr [comp]
@1023E5B5:  add         esp,8
@1023E5B8:  test        eax,eax
@1023E5BA:  jle         @1023E58D
//            }
//            if (mid <= loguy) {
@1023E5BC:  mov         edx,dword ptr [mid]
@1023E5BF:  cmp         edx,dword ptr [loguy]
@1023E5C5:  ja          @1023E5F9
//                do  {
//                    loguy += width;
@1023E5C7:  mov         eax,dword ptr [loguy]
@1023E5CD:  add         eax,dword ptr [width]
@1023E5D0:  mov         dword ptr [loguy],eax
//                } while (loguy <= hi && comp(loguy, mid) <= 0);
@1023E5D6:  mov         ecx,dword ptr [loguy]
@1023E5DC:  cmp         ecx,dword ptr [hi]
@1023E5E2:  ja          @1023E5F9
@1023E5E4:  mov         edx,dword ptr [mid]
@1023E5E7:  push        edx
@1023E5E8:  mov         eax,dword ptr [loguy]
@1023E5EE:  push        eax
@1023E5EF:  call        dword ptr [comp]
@1023E5F2:  add         esp,8
@1023E5F5:  test        eax,eax
@1023E5F7:  jle         @1023E5C7
(*            }

            /* lo < loguy <= hi+1, A[i] <= A[mid] for lo <= i < loguy,
               either loguy > hi or A[loguy] > A[mid] */

            do  {
                higuy -= width;*)
@1023E5F9:  mov         ecx,dword ptr [higuy]
@1023E5FF:  sub         ecx,dword ptr [width]
@1023E602:  mov         dword ptr [higuy],ecx
//            } while (higuy > mid && comp(higuy, mid) > 0);
@1023E608:  mov         edx,dword ptr [higuy]
@1023E60E:  cmp         edx,dword ptr [mid]
@1023E611:  jbe         @1023E628
@1023E613:  mov         eax,dword ptr [mid]
@1023E616:  push        eax
@1023E617:  mov         ecx,dword ptr [higuy]
@1023E61D:  push        ecx
@1023E61E:  call        dword ptr [comp]
@1023E621:  add         esp,8
@1023E624:  test        eax,eax
@1023E626:  jg          @1023E5F9

{            /* lo <= higuy < hi, A[i] > A[mid] for higuy < i < hi,
               either higuy == lo or A[higuy] <= A[mid] */

            if (higuy < loguy)}
@1023E628:  mov         edx,dword ptr [higuy]
@1023E62E:  cmp         edx,dword ptr [loguy]
@1023E634:  jae         @1023E638
//                break;
@1023E636:  jmp         @1023E66B
{
            /* if loguy > hi or higuy == lo, then we would have exited, so
               A[loguy] > A[mid], A[higuy] <= A[mid],
               loguy <= hi, higuy > lo */

            swap(loguy, higuy, width);}
@1023E638:  mov         eax,dword ptr [width]
@1023E63B:  push        eax
@1023E63C:  mov         ecx,dword ptr [higuy]
@1023E642:  push        ecx
@1023E643:  mov         edx,dword ptr [loguy]
@1023E649:  push        edx
@1023E64A:  call        swap //(1023E870h)
@1023E64F:  add         esp,0Ch

{            /* If the partition element was moved, follow it.  Only need
               to check for mid == higuy, since before the swap,
               A[loguy] > A[mid] implies loguy != mid. */

            if (mid == higuy)}
@1023E652:  mov         eax,dword ptr [mid]
@1023E655:  cmp         eax,dword ptr [higuy]
@1023E65B:  jne         @1023E666
//                mid = loguy;
@1023E65D:  mov         ecx,dword ptr [loguy]
@1023E663:  mov         dword ptr [mid],ecx

(*            /* A[loguy] <= A[mid], A[higuy] > A[mid]; so condition at top
               of loop is re-established */
        }*)
@1023E666:  jmp         @1023E582

{        /*     A[i] <= A[mid] for lo <= i < loguy,
               A[i] > A[mid] for higuy < i < hi,
               A[hi] >= A[mid]
               higuy < loguy
           implying:
               higuy == loguy-1
               or higuy == hi - 1, loguy == hi + 1, A[hi] == A[mid] */

        /* Find adjacent elements equal to the partition element.  The
           doubled loop is to avoid calling comp(mid,mid), since some
           existing comparison funcs don't work when passed the same value
           for both pointers. */

        higuy += width;}
@1023E66B:  mov         edx,dword ptr [higuy]
@1023E671:  add         edx,dword ptr [width]
@1023E674:  mov         dword ptr [higuy],edx
//        if (mid < higuy) {
@1023E67A:  mov         eax,dword ptr [mid]
@1023E67D:  cmp         eax,dword ptr [higuy]
@1023E683:  jae         @1023E6B4
{            do  {
                higuy -= width;}
@1023E685:  mov         ecx,dword ptr [higuy]
@1023E68B:  sub         ecx,dword ptr [width]
@1023E68E:  mov         dword ptr [higuy],ecx
//            } while (higuy > mid && comp(higuy, mid) == 0);
@1023E694:  mov         edx,dword ptr [higuy]
@1023E69A:  cmp         edx,dword ptr [mid]
@1023E69D:  jbe         @1023E6B4
@1023E69F:  mov         eax,dword ptr [mid]
@1023E6A2:  push        eax
@1023E6A3:  mov         ecx,dword ptr [higuy]
@1023E6A9:  push        ecx
@1023E6AA:  call        dword ptr [comp]
@1023E6AD:  add         esp,8
@1023E6B0:  test        eax,eax
@1023E6B2:  je          @1023E685
(*        }
        if (mid >= higuy) {*)
@1023E6B4:  mov         edx,dword ptr [mid]
@1023E6B7:  cmp         edx,dword ptr [higuy]
@1023E6BD:  jb          @1023E6EE
{            do  {
                higuy -= width;}
@1023E6BF:  mov         eax,dword ptr [higuy]
@1023E6C5:  sub         eax,dword ptr [width]
@1023E6C8:  mov         dword ptr [higuy],eax
//            } while (higuy > lo && comp(higuy, mid) == 0);
@1023E6CE:  mov         ecx,dword ptr [higuy]
@1023E6D4:  cmp         ecx,dword ptr [lo]
@1023E6D7:  jbe         @1023E6EE
@1023E6D9:  mov         edx,dword ptr [mid]
@1023E6DC:  push        edx
@1023E6DD:  mov         eax,dword ptr [higuy]
@1023E6E3:  push        eax
@1023E6E4:  call        dword ptr [comp]
@1023E6E7:  add         esp,8
@1023E6EA:  test        eax,eax
@1023E6EC:  je          @1023E6BF
(*        }

        /* OK, now we have the following:
              higuy < loguy
              lo <= higuy <= hi
              A[i]  <= A[mid] for lo <= i <= higuy
              A[i]  == A[mid] for higuy < i < loguy
              A[i]  >  A[mid] for loguy <= i < hi
              A[hi] >= A[mid] */

        /* We've finished the partition, now we want to sort the subarrays
           [lo, higuy] and [loguy, hi].
           We do the smaller one first to minimize stack usage.
           We only sort arrays of length 2 or more.*/

        if ( higuy - lo >= hi - loguy ) {*)
@1023E6EE:  mov         ecx,dword ptr [higuy]
@1023E6F4:  sub         ecx,dword ptr [lo]
@1023E6F7:  mov         edx,dword ptr [hi]
@1023E6FD:  sub         edx,dword ptr [loguy]
@1023E703:  cmp         ecx,edx
@1023E705:  jl          @1023E75F
//            if (lo < higuy) {
@1023E707:  mov         eax,dword ptr [lo]
@1023E70A:  cmp         eax,dword ptr [higuy]
@1023E710:  jae         @1023E741
//                lostk[stkptr] = lo;
@1023E712:  mov         ecx,dword ptr [stkptr]
@1023E718:  mov         edx,dword ptr [lo]
@1023E71B:  mov         dword ptr lostk[ecx*4],edx
//                histk[stkptr] = higuy;
@1023E722:  mov         eax,dword ptr [stkptr]
@1023E728:  mov         ecx,dword ptr [higuy]
@1023E72E:  mov         dword ptr histk[eax*4],ecx
//                ++stkptr;
@1023E732:  mov         edx,dword ptr [stkptr]
@1023E738:  add         edx,1
@1023E73B:  mov         dword ptr [stkptr],edx
(*            }                           /* save big recursion for later */

            if (loguy < hi) {*)
@1023E741:  mov         eax,dword ptr [loguy]
@1023E747:  cmp         eax,dword ptr [hi]
@1023E74D:  jae         @1023E75D
//                lo = loguy;
@1023E74F:  mov         ecx,dword ptr [loguy]
@1023E755:  mov         dword ptr [lo],ecx
//                goto recurse;           /* do small recursion */
@1023E758:  jmp         @1023E49D
(*            }
        }
        else {*)
@1023E75D:  jmp         @1023E7BB
//            if (loguy < hi) {
@1023E75F:  mov         edx,dword ptr [loguy]
@1023E765:  cmp         edx,dword ptr [hi]
@1023E76B:  jae         @1023E79F
//                lostk[stkptr] = loguy;
@1023E76D:  mov         eax,dword ptr [stkptr]
@1023E773:  mov         ecx,dword ptr [loguy]
@1023E779:  mov         dword ptr lostk[eax*4],ecx
//                histk[stkptr] = hi;
@1023E780:  mov         edx,dword ptr [stkptr]
@1023E786:  mov         eax,dword ptr [hi]
@1023E78C:  mov         dword ptr histk[edx*4],eax
//                ++stkptr;               /* save big recursion for later */
@1023E790:  mov         ecx,dword ptr [stkptr]
@1023E796:  add         ecx,1
@1023E799:  mov         dword ptr [stkptr],ecx
(*            }

            if (lo < higuy) {*)
@1023E79F:  mov         edx,dword ptr [lo]
@1023E7A2:  cmp         edx,dword ptr [higuy]
@1023E7A8:  jae         @1023E7BB
//                hi = higuy;
@1023E7AA:  mov         eax,dword ptr [higuy]
@1023E7B0:  mov         dword ptr [hi],eax
//                goto recurse;           /* do small recursion */
@1023E7B6:  jmp         @1023E49D
(*            }
        }
    }

    /* We have sorted the array, except for any pending sorts on the stack.
       Check if there are any, and do them. */

    --stkptr;*)
@1023E7BB:  mov         ecx,dword ptr [stkptr]
@1023E7C1:  sub         ecx,1
@1023E7C4:  mov         dword ptr [stkptr],ecx
//    if (stkptr >= 0) {
@1023E7CA:  js          @1023E7F1
//        lo = lostk[stkptr];
@1023E7CC:  mov         edx,dword ptr [stkptr]
@1023E7D2:  mov         eax,dword ptr lostk[edx*4]
@1023E7D9:  mov         dword ptr [lo],eax
//        hi = histk[stkptr];
@1023E7DC:  mov         ecx,dword ptr [stkptr]
@1023E7E2:  mov         edx,dword ptr histk[ecx*4]
@1023E7E6:  mov         dword ptr [hi],edx
//        goto recurse;           /* pop subarray from stack */
@1023E7EC:  jmp         @1023E49D
(*    }
    else
        return;                 /* all subarrays done */
}*)
@1023E7F1:  mov         esp,ebp
{@1023E7F3:  pop         ebp
@1023E7F4:  ret}
end;
end;

//##############################################################################

{$IFDEF FPRINTF}
(***
*int fprintf(stream, format, ...) - print formatted data
*
*Purpose:
*       Prints formatted data on the given using the format string to
*       format data and getting as many arguments as called for
*       _output does the real work here
*
*Entry:
*       FILE *stream - stream to print on
*       char *format - format string to control data format/number of arguments
*       followed by arguments to print, number and type controlled by
*       format string
*
*Exit:
*       returns number of characters printed
*
*Exceptions:
*
*******************************************************************************/

int __cdecl fprintf (
        FILE *str,
        const char *format,
        ...
        )
/*
 * 'F'ile (stream) 'PRINT', 'F'ormatted
 *)

function fprintf( str: Pointer; format: PChar; list: Integer ): Integer; stdcall;
var stream: Pointer;
    buffing: Integer;
    retval: Integer;
    arglist: Pointer;
begin
asm
//{
{@10213830:  push        ebp
@10213831:  mov         ebp,esp}
@10213833:  push        0FFFFFFFFh
@10213835:  push        10269E58h
//@1021383A:  push        offset _except_handler3 (1020C034h)
@1021383A:  push        offset @1020C034
@1021383F:  mov         eax,dword ptr fs:[00000000h]
@10213845:  push        eax
@10213846:  mov         dword ptr fs:[0],esp
@1021384D:  add         esp,0FFFFFFE8h
@10213850:  push        ebx
@10213851:  push        esi
@10213852:  push        edi
{        va_list(arglist);
        REG1 FILE *stream;
        REG2 int buffing;
        int retval;

        va_start(arglist, format);}
@10213853:  lea         eax,[ebp+10h]
@10213856:  mov         dword ptr [arglist],eax

//        _ASSERTE(str != NULL);
@10213859:  cmp         dword ptr [str],0
@1021385D:  jne         @1021387D
//@1021385F:  push        offset string "str != NULL" (10269E4Ch)
@1021385F:  push        offset @10269E4C
@10213864:  push        0
@10213866:  push        38h
//@10213868:  push        offset string "fprintf.c" (10269E40h)
@10213868:  push        offset @10269E40
@1021386D:  push        2
@1021386F:  call        _CrtDbgReport //(1020C610h)
@10213874:  add         esp,14h
@10213877:  cmp         eax,1
@1021387A:  jne         @1021387D
@1021387C:  int         3
//        _ASSERTE(format != NULL);
@1021387D:  cmp         dword ptr [format],0
@10213881:  jne         @102138A1
//@10213883:  push        offset string "format != NULL" (10269E30h)
@10213883:  push        offset @10269E30
@10213888:  push        0
@1021388A:  push        39h
//@1021388C:  push        offset string "fprintf.c" (10269E40h)
@1021388C:  push        offset @10269E40
@10213891:  push        2
@10213893:  call        _CrtDbgReport //(1020C610h)
@10213898:  add         esp,14h
@1021389B:  cmp         eax,1
@1021389E:  jne         @102138A1
@102138A0:  int         3

{        /* Init stream pointer */
        stream = str;}
@102138A1:  mov         eax,dword ptr [str]
@102138A4:  mov         dword ptr [stream],eax

{#ifdef _MT
        _lock_str(stream);
102138A7  mov         ecx,dword ptr [stream]
102138AA  push        ecx
102138AB  call        _lock_file (10213420h)
102138B0  add         esp,4
        __try {
@102138B3:  mov         dword ptr [ebp-4],0
#endif  /* _MT */

        buffing = _stbuf(stream);}
@102138BA:  mov         edx,dword ptr [stream]
@102138BD:  push        edx
@102138BE:  call        _stbuf //(10213F10h)
@102138C3:  add         esp,4
@102138C6:  mov         dword ptr [buffing],eax
//        retval = _output(stream,format,arglist);
@102138C9:  mov         eax,dword ptr [arglist]
@102138CC:  push        eax
@102138CD:  mov         ecx,dword ptr [format]
@102138D0:  push        ecx
@102138D1:  mov         edx,dword ptr [stream]
@102138D4:  push        edx
@102138D5:  call        _output //(102140E0h)
@102138DA:  add         esp,0Ch
@102138DD:  mov         dword ptr [retval],eax
//        _ftbuf(buffing, stream);
@102138E0:  mov         eax,dword ptr [stream]
@102138E3:  push        eax
@102138E4:  mov         ecx,dword ptr [buffing]
@102138E7:  push        ecx
@102138E8:  call        _ftbuf (10214050h)
@102138ED:  add         esp,8
@102138F0:  mov         dword ptr [ebp-4],0FFFFFFFFh
@102138F7:  call        $L20238 (102138FEh)
@102138FC:  jmp         $L20241 (1021390Bh)

(*#ifdef _MT
        }
        __finally {
            _unlock_str(stream);
102138FE  mov         edx,dword ptr [stream]
10213901  push        edx
10213902  call        _unlock_file (10213490h)
10213907  add         esp,4
$L20239:
1021390A  ret
        }
#endif  /* _MT *)

//        return(retval);
1021390B  mov         eax,dword ptr [retval]
//}
1021390E  mov         ecx,dword ptr [ebp-10h] 
10213911  mov         dword ptr fs:[0],ecx 
10213918  pop         edi  
10213919  pop         esi  
1021391A  pop         ebx  
1021391B  mov         esp,ebp 
1021391D  pop         ebp  
1021391E  ret              

{$ENDIF FPRINTF}

procedure ErrExit;
begin
  Halt;
end;

procedure Dummy; 
  asm
    int 3
  end;

//##############################################################################

{;***
;char *strstr(str1, str2) - search for str2 in str1
;
;Purpose:
;       finds the first occurrence of str2 in str1
;
;Entry:
;       char *str1 - string to search in
;       char *str2 - string to search for
;
;Exit:
;       returns a pointer to the first occurrence of string2 in
;       string1, or NULL if string2 does not occur in string1
;
;Uses:
;
;Exceptions:
;
;*******************************************************************************


__from_strstr_to_strchr proto

        CODESEG

        public  strstr

strstr  proc}

procedure strstr;
asm

        mov     ecx,[esp + 8]       //; str2 (the string to be searched for)
        push    edi                 //; Preserve edi, ebx and esi
        push    ebx
        push    esi
        mov     dl,[ecx]            //; dl contains first char from str2
        mov     edi,[esp + 10h]     //; str1 (the string to be searched)
        test    dl,dl               //; is str2 empty?
        jz      @empty_str2
        mov     dh,[ecx + 1]        //; second char from str2
        test    dh,dh               //; is str2 a one-character string?
        jz      @strchr_call        //; if so, go use strchr code

//; length of str2 is now known to be > 1 (used later)
//; dl contains first char from str2
//; dh contains second char from str2
//; edi holds str1

@findnext:
        mov     esi,edi             //; esi = edi = pointers to somewhere in str1
        mov     ecx,[esp + 14h]     //; str2

//;use edi instead of esi to eliminate AGI
        mov     al,[edi]            //; al is next char from str1

        add     esi,1               //; increment pointer into str1

        cmp     al,dl
        je      @first_char_found

        test    al,al               //; end of str1?
        jz      @not_found          //; yes, and no match has been found

@loop_start:
        mov     al,[esi]            //; put next char from str1 into al
        add     esi,1               //; increment pointer in str1
@in_loop:
        cmp     al,dl
        je      @first_char_found

        test    al,al               //; end of str1?
        jnz     @loop_start         //; no, go get another char from str1

@not_found:
        pop     esi
        pop     ebx
        pop     edi
        xor     eax,eax
        ret

//; recall that dh contains the second char from str2

@first_char_found:
        mov     al,[esi]            //; put next char from str1 into al
        add     esi,1

        cmp     al,dh               //; compare second chars
        jnz     @in_loop            //; no match, continue search

@two_first_chars_equal:
        lea     edi,[esi - 1]       //; store position of last read char in str1

@compare_loop:
        mov     ah,[ecx + 2]        //; put next char from str2 into ah
        test    ah,ah               //; end of str2?
        jz      @match              //; if so, then a match has been found

        mov     al,[esi]            //; get next char from str1
        add     esi,2               //; bump pointer into str1 by 2

        cmp     al,ah               //; are chars from str1 and str2 equal?
        jne     @findnext           //; no

//; do one more iteration

        mov     al,[ecx + 3]        //; put the next char from str2 into al
        test    al,al               //; end of str2
        jz      @match              //; if so, then a match has been found

        mov     ah,[esi - 1]        //; get next char from str1
        add     ecx,2               //; bump pointer in str1 by 2
        cmp     al,ah               //; are chars from str1 and str2 equal?
        je      @compare_loop

//; no match. test some more chars (to improve execution time for bad strings).

        jmp     @findnext

//; str2 string contains only one character so it's like the strchr functioin

@strchr_call:
        xor     eax,eax
        pop     esi
        pop     ebx
        pop     edi
        mov     al,dl
        jmp     @__from_strstr_to_strchr

//;
//;
//; Match!  Return (ebx - 1)
//;
@match:
        lea     eax,[edi - 1]
        pop     esi
        pop     ebx
        pop     edi
        ret

@empty_str2:           //; empty target string, return src (ANSI mandated)
        mov     eax,edi
        pop     esi
        pop     ebx
        pop     edi
        ret

{;***
;strstr.asm - search for one string inside another
;
;       Copyright (c) Microsoft Corporation. All rights reserved.
;
;Purpose:
;       defines strstr() - search for one string inside another
;
;*******************************************************************************

        .xlist
        include cruntime.inc
        .list

page
;***
;char *strstr(str1, str2) - search for str2 in str1
;
;Purpose:
;       finds the first occurrence of str2 in str1
;
;Entry:
;       char *str1 - string to search in
;       char *str2 - string to search for
;
;Exit:
;       returns a pointer to the first occurrence of string2 in
;       string1, or NULL if string2 does not occur in string1
;
;Uses:
;
;Exceptions:
;
;*******************************************************************************
}

@__from_strstr_to_strchr: // proto

{        CODESEG

        public  strstr

strstr  proc}

        mov     ecx,[esp + 8]       //; str2 (the string to be searched for)

        push    edi                 //; Preserve edi, ebx and esi
        push    ebx
        push    esi

        mov     dl,[ecx]            //; dl contains first char from str2

        mov     edi,[esp + 10h]     //; str1 (the string to be searched)

        test    dl,dl               //; is str2 empty?
        jz      @@empty_str2

        mov     dh,[ecx + 1]        //; second char from str2
        test    dh,dh               //; is str2 a one-character string?
        jz      @@strchr_call         //; if so, go use strchr code

//; length of str2 is now known to be > 1 (used later)
//; dl contains first char from str2
//; dh contains second char from str2
//; edi holds str1

@@findnext:
        mov     esi,edi             //; esi = edi = pointers to somewhere in str1
        mov     ecx,[esp + 14h]     //; str2

//;use edi instead of esi to eliminate AGI
        mov     al,[edi]            //; al is next char from str1

        add     esi,1               //; increment pointer into str1

        cmp     al,dl
        je      @@first_char_found

        test    al,al               //; end of str1?
        jz      @@not_found           //; yes, and no match has been found

@@loop_start:
        mov     al,[esi]            //; put next char from str1 into al
        add     esi,1               //; increment pointer in str1
@@in_loop:
        cmp     al,dl
        je      @@first_char_found

        test    al,al               //; end of str1?
        jnz     @@loop_start          //; no, go get another char from str1

@@not_found:
        pop     esi
        pop     ebx
        pop     edi
        xor     eax,eax
        ret

//; recall that dh contains the second char from str2

@@first_char_found:
        mov     al,[esi]            //; put next char from str1 into al
        add     esi,1

        cmp     al,dh               //; compare second chars
        jnz     @@in_loop             //; no match, continue search

@@two_first_chars_equal:
        lea     edi,[esi - 1]       //; store position of last read char in str1

@@compare_loop:
        mov     ah,[ecx + 2]        //; put next char from str2 into ah
        test    ah,ah               //; end of str2?
        jz      @@match               //; if so, then a match has been found

        mov     al,[esi]            //; get next char from str1
        add     esi,2               //; bump pointer into str1 by 2

        cmp     al,ah               //; are chars from str1 and str2 equal?
        jne     @@findnext            //; no

//; do one more iteration

        mov     al,[ecx + 3]        //; put the next char from str2 into al
        test    al,al               //; end of str2
        jz      @@match               //; if so, then a match has been found

        mov     ah,[esi - 1]        //; get next char from str1
        add     ecx,2               //; bump pointer in str1 by 2
        cmp     al,ah               //; are chars from str1 and str2 equal?
        je      @@compare_loop

//; no match. test some more chars (to improve execution time for bad strings).

        jmp     @@findnext

//; str2 string contains only one character so it's like the strchr functioin

@@strchr_call:
        xor     eax,eax
        pop     esi
        pop     ebx
        pop     edi
        mov     al,dl
        jmp     @__from_strstr_to_strchr

//;
//;
//; Match!  Return (ebx - 1)
//;
@@match:
        lea     eax,[edi - 1]
        pop     esi
        pop     ebx
        pop     edi
        ret

@@empty_str2:           //; empty target string, return src (ANSI mandated)
        mov     eax,edi
        pop     esi
        pop     ebx
        pop     edi
        //ret

end;

//##############################################################################

var dwInCode: Integer = 1; //???  
procedure __global_unwind2; forward;
procedure __local_unwind2; forward;


procedure _NLG_Notify;
asm
{_NLG_Notify1:
1020C009  push        ebx
1020C00A  push        ecx
1020C00B  mov         ebx,offset __NLG_Destination (1027C538h)
1020C010  jmp         __NLG_Go (1020C01Ch)
_NLG_Notify:}
@1020C012:  push        ebx
@1020C013:  push        ecx
@1020C014:  mov         ebx,offset @__NLG_Destination //(1027C538h)
@1020C019:  mov         ecx,dword ptr [dwInCode]

@__NLG_Go:
@1020C01C:  mov         dword ptr [ebx+8],ecx
@1020C01F:  mov         dword ptr [ebx+4],eax
@1020C022:  mov         dword ptr [ebx+0Ch],ebp

@__NLG_Dispatch:
@1020C025:  pop         ecx
@1020C026:  pop         ebx
@1020C027:  ret         4

@__NLG_Destination:
@1027C538:  and         byte ptr ds:[1993h],al
@1027C53E:  add         byte ptr [eax],al
@1027C540:  add         byte ptr [eax],al
@1027C542:  add         byte ptr [eax],al
@1027C544:  add         byte ptr [eax],al
@1027C546:  add         byte ptr [eax],al
end;

{procedure _ValidateEH3RN:
asm
@1020F700:  push        ebp
@1020F701:  mov         ebp,esp
@1020F703:  sub         esp,5Ch
@1020F706:  mov         eax,dword ptr [pRN]
@1020F709:  mov         ecx,dword ptr [eax+8]
@1020F70C:  mov         dword ptr [pScopeTable],ecx
@1020F70F:  mov         edx,dword ptr [pScopeTable]
@1020F712:  and         edx,3
@1020F715:  je          @1020F71E
@1020F717:  xor         eax,eax
@1020F719:  jmp         @1020FAE4
@1020F71E:  mov         eax,dword ptr fs:[00000018h]
@1020F724:  mov         dword ptr [pTIB],eax
@1020F727:  mov         eax,dword ptr [pTIB]
@1020F72A:  mov         ecx,dword ptr [pScopeTable]
@1020F72D:  cmp         ecx,dword ptr [eax+8]
@1020F730:  jb          @1020F744h
@1020F732:  mov         edx,dword ptr [pTIB]
@1020F735:  mov         eax,dword ptr [pScopeTable]
@1020F738:  cmp         eax,dword ptr [edx+4]
@1020F73B:  jae         @1020F744h
@1020F73D:  xor         eax,eax
@1020F73F:  jmp         @1020FAE4
@1020F744:  mov         ecx,dword ptr [pRN]
@1020F747:  cmp         dword ptr [ecx+0Ch],0FFFFFFFFh
@1020F74B:  jne         @1020F757
@1020F74D:  mov         eax,1
@1020F752:  jmp         @1020FAE4
@1020F757:  mov         dword ptr [nFilters],0
@1020F75E:  mov         dword ptr [level],0
@1020F765:  jmp         @1020F770
@1020F767:  mov         edx,dword ptr [level]
@1020F76A:  add         edx,1
@1020F76D:  mov         dword ptr [level],edx
@1020F770:  mov         eax,dword ptr [pRN]
@1020F773:  mov         ecx,dword ptr [level]
@1020F776:  cmp         ecx,dword ptr [eax+0Ch]
@1020F779:  ja          @1020F7BA
@1020F77B:  mov         edx,dword ptr [level]
@1020F77E:  imul        edx,edx,0Ch
@1020F781:  mov         eax,dword ptr [pScopeTable]
@1020F784:  mov         ecx,dword ptr [eax+edx]
@1020F787:  mov         dword ptr [enclosing],ecx
@1020F78A:  cmp         dword ptr [enclosing],0FFFFFFFFh
@1020F78E:  je          @1020F79F
@1020F790:  mov         edx,dword ptr [enclosing]
@1020F793:  cmp         edx,dword ptr [level]
@1020F796:  jb          @1020F79F
@1020F798:  xor         eax,eax
@1020F79A:  jmp         exit_success+0D2h (1020FAE4h)
@1020F79F:  mov         eax,dword ptr [level]
@1020F7A2:  imul        eax,eax,0Ch
@1020F7A5:  mov         ecx,dword ptr [pScopeTable]
@1020F7A8:  cmp         dword ptr [ecx+eax+4],0
@1020F7AD:  je          @1020F7B8
@1020F7AF:  mov         edx,dword ptr [nFilters]
@1020F7B2:  add         edx,1
@1020F7B5:  mov         dword ptr [nFilters],edx
@1020F7B8:  jmp         @1020F767
@1020F7BA:  cmp         dword ptr [nFilters],0
@1020F7BE:  je          @1020F7E0
@1020F7C0:  mov         eax,dword ptr [pRN]
@1020F7C3:  mov         ecx,dword ptr [pTIB]
@1020F7C6:  mov         edx,dword ptr [eax-8]
@1020F7C9:  cmp         edx,dword ptr [ecx+8]
@1020F7CC:  jb          @1020F7D9
@1020F7CE:  mov         eax,dword ptr [pRN]
@1020F7D1:  mov         ecx,dword ptr [eax-8]
@1020F7D4:  cmp         ecx,dword ptr [pRN]
@1020F7D7:  jb          @1020F7E0
@1020F7D9:  xor         eax,eax
@1020F7DB:  jmp         exit_success+0D2h (1020FAE4h)
@1020F7E0:  mov         edx,dword ptr [pScopeTable]
@1020F7E3:  and         edx,0FFFFF000h
@1020F7E9:  mov         dword ptr [pScopePage],edx
@1020F7EC:  mov         dword ptr [iValid],0
@1020F7F3:  jmp         @1020F7FE
@1020F7F5:  mov         eax,dword ptr [iValid]
@1020F7F8:  add         eax,1
@1020F7FB:  mov         dword ptr [iValid],eax
@1020F7FE:  mov         ecx,dword ptr [iValid]
@1020F801:  cmp         ecx,dword ptr [nValidPages (1027F098h)]
@1020F807:  jge         @1020F91E
@1020F80D:  mov         edx,dword ptr [iValid]
@1020F810:  mov         eax,dword ptr [edx*4+1027F0A0h]
@1020F817:  cmp         eax,dword ptr [pScopePage]
@1020F81A:  jne         @1020F919
@1020F820:  cmp         dword ptr [iValid],0
@1020F824:  jle         @1020F90F
@1020F82A:  push        1
@1020F82C:  push        offset lModifying (1027F0E0h)
@1020F831:  call        dword ptr [__imp__InterlockedExchange@8 (10267118h)]
@1020F837:  test        eax,eax
@1020F839:  jne         @1020F90F
@1020F83F:  mov         ecx,dword ptr [iValid]
@1020F842:  mov         edx,dword ptr [ecx*4+1027F0A0h]
@1020F849:  cmp         edx,dword ptr [pScopePage]
@1020F84C:  je          @1020F8C6
@1020F84E:  mov         eax,dword ptr [nValidPages (1027F098h)]
@1020F853:  sub         eax,1
@1020F856:  mov         dword ptr [iValid],eax
@1020F859:  jmp         @1020F864
@1020F85B:  mov         ecx,dword ptr [iValid]
@1020F85E:  sub         ecx,1
@1020F861:  mov         dword ptr [iValid],ecx
@1020F864:  cmp         dword ptr [iValid],0
@1020F868:  jl          @1020F87D
@1020F86A:  mov         edx,dword ptr [iValid]
@1020F86D:  mov         eax,dword ptr [edx*4+1027F0A0h]
@1020F874:  cmp         eax,dword ptr [pScopePage]
@1020F877:  jne         @1020F87B
@1020F879:  jmp         @1020F87D
@1020F87B:  jmp         @1020F85B
@1020F87D:  cmp         dword ptr [iValid],0
@1020F881:  jge         @1020F8A9
@1020F883:  cmp         dword ptr [nValidPages (1027F098h)],10h
@1020F88A:  jge         @1020F89B
@1020F88C:  mov         ecx,dword ptr [nValidPages (1027F098h)]
@1020F892:  add         ecx,1
@1020F895:  mov         dword ptr [nValidPages (1027F098h)],ecx
@1020F89B:  mov         edx,dword ptr [nValidPages (1027F098h)]
@1020F8A1:  sub         edx,1
@1020F8A4:  mov         dword ptr [iValid],edx
@1020F8A7:  jmp         _ValidateEH3RN+1C6h (1020F8C6h)
@1020F8A9:  cmp         dword ptr [iValid],0
@1020F8AD:  jne         _ValidateEH3RN+1C6h (1020F8C6h)
@1020F8AF:  push        0
@1020F8B1:  push        offset lModifying (1027F0E0h)
@1020F8B6:  call        dword ptr [__imp__InterlockedExchange@8 (10267118h)]
@1020F8BC:  mov         eax,1
@1020F8C1:  jmp         exit_success+0D2h (1020FAE4h)
@1020F8C6:  mov         dword ptr [iValid2],0
@1020F8CD:  jmp         _ValidateEH3RN+1D8h (1020F8D8h)
@1020F8CF:  mov         eax,dword ptr [iValid2]
@1020F8D2:  add         eax,1
@1020F8D5:  mov         dword ptr [iValid2],eax
@1020F8D8:  mov         ecx,dword ptr [iValid2]
@1020F8DB:  cmp         ecx,dword ptr [iValid]
@1020F8DE:  jg          _ValidateEH3RN+202h (1020F902h)
@1020F8E0:  mov         edx,dword ptr [iValid2]
@1020F8E3:  mov         eax,dword ptr [edx*4+1027F0A0h]
@1020F8EA:  mov         dword ptr [pTmp],eax
@1020F8ED:  mov         ecx,dword ptr [iValid2]
@1020F8F0:  mov         edx,dword ptr [pScopePage]
@1020F8F3:  mov         dword ptr [ecx*4+1027F0A0h],edx
@1020F8FA:  mov         eax,dword ptr [pTmp]
@1020F8FD:  mov         dword ptr [pScopePage],eax
@1020F900:  jmp         _ValidateEH3RN+1CFh (1020F8CFh)
@1020F902:  push        0
@1020F904:  push        offset lModifying (1027F0E0h)
@1020F909:  call        dword ptr [__imp__InterlockedExchange@8 (10267118h)]
@1020F90F:  mov         eax,1
@1020F914:  jmp         exit_success+0D2h (1020FAE4h)
@1020F919:  jmp         _ValidateEH3RN+0F5h (1020F7F5h)
@1020F91E:  push        1Ch
@1020F920:  lea         ecx,[mbi]
@1020F923:  push        ecx
@1020F924:  mov         edx,dword ptr [pScopeTable]
@1020F927:  push        edx
@1020F928:  call        dword ptr [__imp__VirtualQuery@12 (10267114h)]
@1020F92E:  test        eax,eax
@1020F930:  je          _ValidateEH3RN+23Bh (1020F93Bh)
@1020F932:  cmp         dword ptr [ebp-3Ch],1000000h
@1020F939:  je          _ValidateEH3RN+243h (1020F943h)
@1020F93B:  or          eax,0FFFFFFFFh
@1020F93E:  jmp         exit_success+0D2h (1020FAE4h)
@1020F943:  mov         eax,dword ptr [ebp-40h]
@1020F946:  and         eax,0CCh
@1020F94B:  jne         _ValidateEH3RN+252h (1020F952h)
@1020F94D:  jmp         exit_success (1020FA12h)
@1020F952:  mov         ecx,dword ptr [ebp-50h]
@1020F955:  mov         dword ptr [pDOSHeader],ecx
@1020F958:  mov         edx,dword ptr [pDOSHeader]
@1020F95B:  movzx       eax,word ptr [edx]
@1020F95E:  cmp         eax,5A4Dh
@1020F963:  je          _ValidateEH3RN+26Dh (1020F96Dh)
@1020F965:  or          eax,0FFFFFFFFh
@1020F968:  jmp         exit_success+0D2h (1020FAE4h)
@1020F96D:  mov         ecx,dword ptr [pDOSHeader]
@1020F970:  mov         edx,dword ptr [pDOSHeader]
@1020F973:  add         edx,dword ptr [ecx+3Ch]
@1020F976:  mov         dword ptr [pNTHeader],edx
@1020F979:  mov         eax,dword ptr [pNTHeader]
@1020F97C:  cmp         dword ptr [eax],4550h
@1020F982:  je          _ValidateEH3RN+28Ch (1020F98Ch)
@1020F984:  or          eax,0FFFFFFFFh
@1020F987:  jmp         exit_success+0D2h (1020FAE4h)
@1020F98C:  mov         ecx,dword ptr [pNTHeader]
@1020F98F:  add         ecx,18h
@1020F992:  mov         dword ptr [pOptHeader],ecx
@1020F995:  mov         edx,dword ptr [pOptHeader]
@1020F998:  movzx       eax,word ptr [edx]
@1020F99B:  cmp         eax,10Bh
@1020F9A0:  je          _ValidateEH3RN+2AAh (1020F9AAh)
@1020F9A2:  or          eax,0FFFFFFFFh
@1020F9A5:  jmp         exit_success+0D2h (1020FAE4h)
@1020F9AA:  mov         ecx,dword ptr [pScopeTable]
@1020F9AD:  sub         ecx,dword ptr [pDOSHeader]
@1020F9B0:  mov         dword ptr [rvaScopeTable],ecx
@1020F9B3:  mov         dword ptr [iSection],0
@1020F9BA:  mov         edx,dword ptr [pNTHeader]
@1020F9BD:  movzx       eax,word ptr [edx+14h]
@1020F9C1:  mov         ecx,dword ptr [pNTHeader]
@1020F9C4:  lea         edx,[ecx+eax+18h]
@1020F9C8:  mov         dword ptr [pSection],edx
@1020F9CB:  mov         edx,dword ptr [pNTHeader]
@1020F9CE:  movzx       eax,word ptr [edx+6]
@1020F9D2:  cmp         dword ptr [iSection],eax
@1020F9D5:  jae         _ValidateEH3RN+30Ah (1020FA0Ah)
@1020F9D7:  mov         ecx,dword ptr [pSection]
@1020F9DA:  mov         edx,dword ptr [rvaScopeTable]
@1020F9DD:  cmp         edx,dword ptr [ecx+0Ch]
@1020F9E0:  jb          _ValidateEH3RN+308h (1020FA08h)
@1020F9E2:  mov         eax,dword ptr [pSection]
@1020F9E5:  mov         ecx,dword ptr [eax+0Ch]
@1020F9E8:  mov         edx,dword ptr [pSection]
@1020F9EB:  add         ecx,dword ptr [edx+8]
@1020F9EE:  cmp         dword ptr [rvaScopeTable],ecx
@1020F9F1:  jae         _ValidateEH3RN+308h (1020FA08h)
@1020F9F3:  mov         eax,dword ptr [pSection]
@1020F9F6:  mov         ecx,dword ptr [eax+24h]
@1020F9F9:  and         ecx,80000000h
@1020F9FF:  je          _ValidateEH3RN+308h (1020FA08h)
@1020FA01:  xor         eax,eax
@1020FA03:  jmp         exit_success+0D2h (1020FAE4h)
@1020FA08:  jmp         exit_success (1020FA12h)
@1020FA0A:  or          eax,0FFFFFFFFh
@1020FA0D:  jmp         exit_success+0D2h (1020FAE4h)

@exit_success:
@1020FA12:  push        1
@1020FA14:  push        offset lModifying (1027F0E0h)
@1020FA19:  call        dword ptr [__imp__InterlockedExchange@8 (10267118h)]
@1020FA1F:  test        eax,eax
@1020FA21:  je          exit_success+1Bh (1020FA2Dh)
@1020FA23:  mov         eax,1
@1020FA28:  jmp         exit_success+0D2h (1020FAE4h)
@1020FA2D:  mov         edx,dword ptr [nValidPages (1027F098h)]
@1020FA33:  mov         dword ptr [iValid],edx
@1020FA36:  jmp         exit_success+2Fh (1020FA41h)
@1020FA38:  mov         eax,dword ptr [iValid]
@1020FA3B:  sub         eax,1
@1020FA3E:  mov         dword ptr [iValid],eax
@1020FA41:  cmp         dword ptr [iValid],0
@1020FA45:  jle         exit_success+48h (1020FA5Ah)
@1020FA47:  mov         ecx,dword ptr [iValid]
@1020FA4A:  mov         edx,dword ptr [ecx*4+1027F09Ch]
@1020FA51:  cmp         edx,dword ptr [pScopePage]
@1020FA54:  jne         exit_success+46h (1020FA58h)
@1020FA56:  jmp         exit_success+48h (1020FA5Ah)
@1020FA58:  jmp         exit_success+26h (1020FA38h)
@1020FA5A:  cmp         dword ptr [iValid],0
@1020FA5E:  jne         exit_success+0C0h (1020FAD2h)
@1020FA60:  cmp         dword ptr [nValidPages (1027F098h)],0Fh
@1020FA67:  jle         exit_success+60h (1020FA72h)
@1020FA69:  mov         dword ptr [ebp-5Ch],0Fh
@1020FA70:  jmp         exit_success+68h (1020FA7Ah)
@1020FA72:  mov         eax,dword ptr [nValidPages (1027F098h)]
@1020FA77:  mov         dword ptr [ebp-5Ch],eax
@1020FA7A:  mov         ecx,dword ptr [ebp-5Ch]
@1020FA7D:  mov         dword ptr [iValid],ecx
@1020FA80:  mov         dword ptr [iValid2],0
@1020FA87:  jmp         exit_success+80h (1020FA92h)
@1020FA89:  mov         edx,dword ptr [iValid2]
@1020FA8C:  add         edx,1
@1020FA8F:  mov         dword ptr [iValid2],edx
@1020FA92:  mov         eax,dword ptr [iValid2]
@1020FA95:  cmp         eax,dword ptr [iValid]
@1020FA98:  jg          exit_success+0AAh (1020FABCh)
@1020FA9A:  mov         ecx,dword ptr [iValid2]
@1020FA9D:  mov         edx,dword ptr [ecx*4+1027F0A0h]
@1020FAA4:  mov         dword ptr [pTmp],edx
@1020FAA7:  mov         eax,dword ptr [iValid2]
@1020FAAA:  mov         ecx,dword ptr [pScopePage]
@1020FAAD:  mov         dword ptr [eax*4+1027F0A0h],ecx
@1020FAB4:  mov         edx,dword ptr [pTmp]
@1020FAB7:  mov         dword ptr [pScopePage],edx
@1020FABA:  jmp         exit_success+77h (1020FA89h)
@1020FABC:  cmp         dword ptr [nValidPages (1027F098h)],10h
@1020FAC3:  jge         exit_success+0C0h (1020FAD2h)
@1020FAC5:  mov         eax,dword ptr [nValidPages (1027F098h)]
@1020FACA:  add         eax,1
@1020FACD:  mov         dword ptr [nValidPages (1027F098h)],eax
@1020FAD2:  push        0
@1020FAD4:  push        offset lModifying (1027F0E0h)
@1020FAD9:  call        dword ptr [__imp__InterlockedExchange@8 (10267118h)]
@1020FADF:  mov         eax,1
@1020FAE4:  mov         esp,ebp
@1020FAE6:  pop         ebp
//@1020FAE7:  ret
end;}

procedure _except_handler3;
asm
//_except_handler3:
@1020C034:  push        ebp
@1020C035:  mov         ebp,esp
@1020C037:  sub         esp,8
@1020C03A:  push        ebx
@1020C03B:  push        esi
@1020C03C:  push        edi
@1020C03D:  push        ebp
@1020C03E:  cld
@1020C03F:  mov         ebx,dword ptr [ebp+0Ch]
@1020C042:  mov         eax,dword ptr [ebp+8]
@1020C045:  test        dword ptr [eax+4],6
@1020C04C:  jne         @_lh_unwinding //(1020C0FDh)
@1020C052:  mov         dword ptr [ebp-8],eax
@1020C055:  mov         eax,dword ptr [ebp+10h]
@1020C058:  mov         dword ptr [ebp-4],eax
@1020C05B:  lea         eax,[ebp-8]
@1020C05E:  mov         dword ptr [ebx-4],eax
@1020C061:  mov         esi,dword ptr [ebx+0Ch]
@1020C064:  mov         edi,dword ptr [ebx+8]
//@1020C067:  push        ebx
//@1020C068:  call        _ValidateEH3RN //(1020F700h)
//@1020C06D:  add         esp,4
//@1020C070:  or          eax,eax
//@1020C072:  je          @_lh_abort (1020C0EFh)

@_lh_top:
@1020C074:  cmp         esi,0FFFFFFFFh
@1020C077:  je          @_lh_bagit //(1020C0F6h)
@1020C079:  lea         ecx,[esi+esi*2]
@1020C07C:  mov         eax,dword ptr [edi+ecx*4+4]
@1020C080:  or          eax,eax
@1020C082:  je          @_lh_continue //(1020C0DDh)
@1020C084:  push        esi
@1020C085:  push        ebp
@1020C086:  lea         ebp,[ebx+10h]
@1020C089:  xor         ebx,ebx
@1020C08B:  xor         ecx,ecx
@1020C08D:  xor         edx,edx
@1020C08F:  xor         esi,esi
@1020C091:  xor         edi,edi
@1020C093:  call        eax
@1020C095:  pop         ebp
@1020C096:  pop         esi
@1020C097:  mov         ebx,dword ptr [ebp+0Ch]
@1020C09A:  or          eax,eax
@1020C09C:  je          @_lh_continue //(1020C0DDh)
@1020C09E:  js          @_lh_dismiss //(1020C0E8h)
@1020C0A0:  mov         edi,dword ptr [ebx+8]
@1020C0A3:  push        ebx
@1020C0A4:  call        __global_unwind2 //(1020BF3Ch)
@1020C0A9:  add         esp,4
@1020C0AC:  lea         ebp,[ebx+10h]
@1020C0AF:  push        esi
@1020C0B0:  push        ebx
@1020C0B1:  call        __local_unwind2 //(1020BF7Eh)
@1020C0B6:  add         esp,8
@1020C0B9:  lea         ecx,[esi+esi*2]
@1020C0BC:  push        1
@1020C0BE:  mov         eax,dword ptr [edi+ecx*4+8]
@1020C0C2:  call        _NLG_Notify //(1020C012h)
@1020C0C7:  mov         eax,dword ptr [edi+ecx*4]
@1020C0CA:  mov         dword ptr [ebx+0Ch],eax
@1020C0CD:  mov         eax,dword ptr [edi+ecx*4+8]
@1020C0D1:  xor         ebx,ebx
@1020C0D3:  xor         ecx,ecx
@1020C0D5:  xor         edx,edx
@1020C0D7:  xor         esi,esi
@1020C0D9:  xor         edi,edi
@1020C0DB:  call        eax

@_lh_continue:
@1020C0DD:  mov         edi,dword ptr [ebx+8]
@1020C0E0:  lea         ecx,[esi+esi*2]
@1020C0E3:  mov         esi,dword ptr [edi+ecx*4]
@1020C0E6:  jmp         @_lh_top //(1020C074h)

@_lh_dismiss:
@1020C0E8:  mov         eax,0
@1020C0ED:  jmp         @_lh_return (1020C112h)

@_lh_abort:
@1020C0EF:  mov         eax,dword ptr [ebp+8]
@1020C0F2:  or          dword ptr [eax+4],8

@_lh_bagit:
@1020C0F6:  mov         eax,1
@1020C0FB:  jmp         @_lh_return //(1020C112h)

@_lh_unwinding:
@1020C0FD:  push        ebp
@1020C0FE:  lea         ebp,[ebx+10h]
@1020C101:  push        0FFFFFFFFh
@1020C103:  push        ebx
@1020C104:  call        __local_unwind2 //(1020BF7Eh)
@1020C109:  add         esp,8
@1020C10C:  pop         ebp
@1020C10D:  mov         eax,1

@_lh_return:
@1020C112:  pop         ebp
@1020C113:  pop         edi
@1020C114:  pop         esi
@1020C115:  pop         ebx
@1020C116:  mov         esp,ebp
@1020C118:  pop         ebp
//@1020C119:  ret
end;

procedure RtlUnwind( TargetFrame, TargetIp: Pointer;
  ExceptionRecord: Pointer {PEXCEPTION_RECORD };
  ReturnValue: Pointer ); stdcall; external 'kernel32.dll' name 'RtlUnwind';

procedure __global_unwind2;
asm
@1020BF3C:  push        ebp
@1020BF3D:  mov         ebp,esp
@1020BF3F:  push        ebx
@1020BF40:  push        esi
@1020BF41:  push        edi
@1020BF42:  push        ebp
@1020BF43:  push        0
@1020BF45:  push        0
@1020BF47:  push        offset @_gu_return //(1020BF54h)
@1020BF4C:  push        dword ptr [ebp+8]
@1020BF4F:  call        RtlUnwind //(102193A8h)

@_gu_return:
@1020BF54:  pop         ebp
@1020BF55:  pop         edi
@1020BF56:  pop         esi
@1020BF57:  pop         ebx
@1020BF58:  mov         esp,ebp
@1020BF5A:  pop         ebp
//@1020BF5B:  ret
end;

procedure __unwind_handler;
asm
@1020BF5C:  mov         ecx,dword ptr [esp+4]
@1020BF60:  test        dword ptr [ecx+4],6
@1020BF67:  mov         eax,1
@1020BF6C:  je          @_uh_return //(1020BF7Dh)
@1020BF6E:  mov         eax,dword ptr [esp+8]
@1020BF72:  mov         edx,dword ptr [esp+10h]
@1020BF76:  mov         dword ptr [edx],eax
@1020BF78:  mov         eax,3

@_uh_return:
//@1020BF7D  ret
end;

procedure __local_unwind2;
asm
@1020BF7E:  push        ebx
@1020BF7F:  push        esi
@1020BF80:  push        edi
@1020BF81:  mov         eax,dword ptr [esp+10h]
@1020BF85:  push        eax
@1020BF86:  push        0FFFFFFFEh
@1020BF88:  push        offset __unwind_handler //(1020BF5Ch)
@1020BF8D:  push        dword ptr fs:[0]
@1020BF94:  mov         dword ptr fs:[0],esp

@_lu_top:
@1020BF9B:  mov         eax,dword ptr [esp+20h]
@1020BF9F:  mov         ebx,dword ptr [eax+8]
@1020BFA2:  mov         esi,dword ptr [eax+0Ch]
@1020BFA5:  cmp         esi,0FFFFFFFFh
@1020BFA8:  je          @_lu_done (1020BFD8h)
@1020BFAA:  cmp         esi,dword ptr [esp+24h]
@1020BFAE:  je          @_lu_done (1020BFD8h)
@1020BFB0:  lea         esi,[esi+esi*2]
@1020BFB3:  mov         ecx,dword ptr [ebx+esi*4]
@1020BFB6:  mov         dword ptr [esp+8],ecx
@1020BFBA:  mov         dword ptr [eax+0Ch],ecx
@1020BFBD:  cmp         dword ptr [ebx+esi*4+4],0
@1020BFC2:  jne         @_lu_continue (1020BFD6h)
@1020BFC4:  push        101h
@1020BFC9:  mov         eax,dword ptr [ebx+esi*4+8]
@1020BFCD:  call        _NLG_Notify //(1020C012h)
@1020BFD2:  call        dword ptr [ebx+esi*4+8]

@_lu_continue:
@1020BFD6:  jmp         @_lu_top (1020BF9Bh)

@_lu_done:
@1020BFD8:  pop         dword ptr fs:[0]
@1020BFDF:  add         esp,0Ch
@1020BFE2:  pop         edi
@1020BFE3:  pop         esi
@1020BFE4:  pop         ebx
//@1020BFE5:  ret
end;

procedure longjmp;
asm
@1023E2C4:  mov         ebx,dword ptr [esp+4]
@1023E2C8:  mov         ebp,dword ptr [ebx]
@1023E2CA:  mov         esi,dword ptr [ebx+18h]
@1023E2CD:  cmp         esi,dword ptr fs:[0]
{@1023E2D4:  je          @_lj_local_unwind //(1023E2DFh)
@1023E2D6:  push        esi
@1023E2D7:  call        __global_unwind2 //(1020BF3Ch)
@1023E2DC:  add         esp,4}

@_lj_local_unwind:
@1023E2DF:  cmp         esi,0
//@1023E2E2:  je          @_lj_no_unwind //(1023E314h)
{@1023E2E2:  jmp         @_lj_no_unwind //(1023E314h)
@1023E2E4:  lea         eax,[ebx+20h]
@1023E2E7:  push        eax
@1023E2E8:  call        @_rt_probe_read4 //(1023EE60h)
@1023E2ED:  or          eax,eax
@1023E2EF:  je          @_lj_old_unwind //(1023E307h)
@1023E2F1:  mov         eax,dword ptr [ebx+20h]
@1023E2F4:  cmp         eax,56433230h
@1023E2F9:  jne         @_lj_old_unwind (1023E307h)
@1023E2FB:  mov         eax,dword ptr [ebx+24h]
@1023E2FE:  or          eax,eax
@1023E300:  je          @_lj_no_unwind //(1023E314h)
@1023E302:  push        ebx
@1023E303:  call        eax
@1023E305:  jmp         @_lj_no_unwind //(1023E314h)

@_lj_old_unwind:
@1023E307:  mov         eax,dword ptr [ebx+1Ch]
@1023E30A:  push        eax
@1023E30B:  push        esi
@1023E30C:  call        __local_unwind2 //(1020BF7Eh)
@1023E311:  add         esp,8}

@_lj_no_unwind:
@1023E314:  push        0
@1023E316:  mov         eax,dword ptr [ebx+14h]
@1023E319:  call        _NLG_Notify //(1020C012h)
@1023E31E:  mov         edx,ebx
@1023E320:  mov         ebx,dword ptr [edx+4]
@1023E323:  mov         edi,dword ptr [edx+8]
@1023E326:  mov         esi,dword ptr [edx+0Ch]
@1023E329:  mov         eax,dword ptr [esp+8]
@1023E32D:  cmp         eax,1
@1023E330:  adc         eax,0
@1023E333:  mov         esp,dword ptr [edx+10h]
@1023E336:  add         esp,4
@1023E339:  jmp         dword ptr [edx+14h]
@1023E33C:  ret

{@_rt_probe_read4:
@1023EE60:  push        ebp
@1023EE61:  mov         ebp,esp
@1023EE63:  push        0FFFFFFFFh
@1023EE65:  push        1026C480h
@1023EE6A:  push        offset _except_handler3 //(1020C034h)
@1023EE6F:  mov         eax,dword ptr fs:[00000000h]
@1023EE75:  push        eax
@1023EE76:  mov         dword ptr fs:[0],esp
@1023EE7D:  add         esp,0FFFFFFECh
@1023EE80:  push        ebx
@1023EE81:  push        esi
@1023EE82:  push        edi
@1023EE83:  mov         dword ptr [ebp-18h],esp
@1023EE86:  mov         dword ptr [ebp-4],0
@1023EE8D:  mov         eax,dword ptr [ebp+4]//[ptr]
@1023EE90:  mov         ecx,dword ptr [eax]
@1023EE92:  mov         dword ptr [ebp-24h],ecx
@1023EE95:  mov         dword ptr [readable],1
@1023EE9C:  mov         dword ptr [ebp-4],0FFFFFFFFh
@1023EEA3:  jmp         @1023EECE

@L19221:
@1023EEA5:  mov         edx,dword ptr [ebp-14h]
@1023EEA8:  mov         eax,dword ptr [edx]
@1023EEAA:  mov         ecx,dword ptr [eax]
@1023EEAC:  mov         dword ptr [ebp-20h],ecx
@1023EEAF:  mov         eax,dword ptr [ebp-20h]
@1023EEB2:  sub         eax,0C0000005h
@1023EEB7:  neg         eax
@1023EEB9:  sbb         eax,eax
@1023EEBB:  inc         eax

@L19223:
@1023EEBC:  ret

@L19222:
@1023EEBD:  mov         esp,dword ptr [ebp-18h]
@1023EEC0:  mov         dword ptr [readable],0
@1023EEC7:  mov         dword ptr [ebp-4],0FFFFFFFFh
@1023EECE:  mov         eax,dword ptr [readable]
@1023EED1:  mov         ecx,dword ptr [ebp-10h]
@1023EED4:  mov         dword ptr fs:[0],ecx
@1023EEDB:  pop         edi
@1023EEDC:  pop         esi
@1023EEDD:  pop         ebx
@1023EEDE:  mov         esp,ebp
@1023EEE0:  pop         ebp
@1023EEE1:  ret         4}

end;

procedure __setjmp3;
asm
@1023CFDC:  mov         edx,dword ptr [esp+4]
@1023CFE0:  mov         dword ptr [edx],ebp
@1023CFE2:  mov         dword ptr [edx+4],ebx
@1023CFE5:  mov         dword ptr [edx+8],edi
@1023CFE8:  mov         dword ptr [edx+0Ch],esi
@1023CFEB:  mov         dword ptr [edx+10h],esp
@1023CFEE:  mov         eax,dword ptr [esp]
@1023CFF1:  mov         dword ptr [edx+14h],eax
@1023CFF4:  mov         dword ptr [edx+20h],56433230h
@1023CFFB:  mov         dword ptr [edx+24h],0
@1023D002:  mov         eax,dword ptr fs:[00000000h]
@1023D008:  mov         dword ptr [edx+18h],eax
@1023D00B:  cmp         eax,0FFFFFFFFh
@1023D00E:  jne         @_s3_get_count (1023D019h)
@1023D010:  mov         dword ptr [edx+1Ch],0FFFFFFFFh
@1023D017:  jmp         @_s3_done (1023D054h)

@_s3_get_count:
@1023D019:  mov         ecx,dword ptr [esp+8]
@1023D01D:  or          ecx,ecx
@1023D01F:  je          @_s3_default_trylevel //(1023D02Bh)
@1023D021:  mov         eax,dword ptr [esp+0Ch]
@1023D025:  mov         dword ptr [edx+24h],eax
@1023D028:  dec         ecx
@1023D029:  jne         @_s3_save_trylevel //(1023D033h)

@_s3_default_trylevel:
@1023D02B:  mov         eax,dword ptr [eax+0Ch]
@1023D02E:  mov         dword ptr [edx+1Ch],eax
@1023D031:  jmp         @_s3_done //(1023D054h)

@_s3_save_trylevel:
@1023D033:  mov         eax,dword ptr [esp+10h]
@1023D037:  mov         dword ptr [edx+1Ch],eax
@1023D03A:  dec         ecx
@1023D03B:  je          @_s3_done //(1023D054h)
@1023D03D:  push        esi
@1023D03E:  push        edi
@1023D03F:  lea         esi,[esp+1Ch]
@1023D043:  lea         edi,[edx+28h]
@1023D046:  cmp         ecx,6
@1023D049:  jbe         @_s3_save_data //(1023D050h)
@1023D04B:  mov         ecx,6

@_s3_save_data:
@1023D050:  rep movs    dword ptr [edi],dword ptr [esi]
@1023D052:  pop         edi
@1023D053:  pop         esi

@_s3_done:
@1023D054:  sub         eax,eax
//@1023D056:  ret
end;

procedure __purecall;
begin
  asm
    int 3 //   ?
  end;
end;

end.
